#include "xfsp.h"
#include <stdio.h>

extern Display *dpy;
extern Window win, hostwin, aboutwin;
extern int screen_num;
extern char hostname[40], portname[6], lfilname[30], rdirname[70];
extern char rfilname[30], currdir[70], hostf[40];
extern char dates[256][20], sizes[10], names[30], home[60];
extern int  dirs[256], dirlen, entries, topent, hoston, tophost, numhosts;
extern XEvent event;

char tempname[L_tmpnam];
KeySym keysym;
XComposeStatus compose;
int litbutton, litstr;

keyhandler()
{
 int count, i, len, maxlen, buflen = 10;
 char buffer[10], compstr[70];

 count = XLookupString(&event, buffer, buflen, &keysym, &compose);
 if (!litstr) XBell(dpy, 100);
 else
 {
 switch (litstr) {
 case 1:
      strcpy(compstr,hostname);
      maxlen = 50;
      break;
 case 2:
      strcpy(compstr,portname);
      maxlen = 9;
      break;
 case 3:
      strcpy(compstr,rdirname);
      maxlen = 70;
      break;
 case 4:
      strcpy(compstr,lfilname);
      maxlen = 30;
      break;
  case 5:
      strcpy(compstr,rfilname);
      maxlen = 30;
      break;
  case 6:
      strcpy(compstr,hostf);
      maxlen = 40;
      break;
  }     
  if ((keysym == XK_Linefeed) || (keysym == XK_KP_Enter)
            || (keysym == XK_Return)) {
     if (litstr <= 3) {
      entries = 0;
      showentries();
      }
     if (litstr == 6) {
      readhosts();
      showhosts();
     }
     litstr = 0;
    }
    else if ((keysym >= XK_exclam) && (keysym <= XK_asciitilde)) {
       if ((strlen(compstr) + strlen(buffer)) >= maxlen)
         XBell(dpy, 100);
       else
         strcat(compstr, buffer);
       }
     else if ((keysym == XK_BackSpace) || (keysym == XK_Delete)) {
        if ((len = strlen(compstr)) > 0) {
           compstr[len - 1] = NULL;
         }
         else XBell(dpy, 100);
       }
   switch (litstr) {
   case 1:
      strcpy(hostname, compstr);
      break;
   case 2:
      strcpy(portname, compstr);
      break;
   case 3:
      strcpy(rdirname, compstr);
      break;
   case 4:
      strcpy(lfilname, compstr);
      break;
   case 5:
      strcpy(rfilname, compstr);
      break;
   case 6:
      strcpy(hostf, compstr);
      break;
    }
    showstrings();
  }
}

buttonhandler(bx, by, bw, lit)
int bx, by, lit;
Window bw;
{
 int status;
 char tempstr[60];

 if (bw == aboutwin) {
  XUnmapWindow(dpy, aboutwin);
  mainscr();
 }
 if (bw == win) {
 if (!lit) {
  switch(litbutton) {
       case 1:
            button(10, 290, "host", win, 0);
            break;
       case 2:
            button(380, 290, "port", win, 0);
            break;
       case 3:
            button(10, 310, "r-dir", win,0);
            break;
       case 4:
            button(250, 330, "lfile", win, 0);
            break;
       case 5:
            button(10,  370, "hosts", win,0);
            if (!hoston) hosts();
            break;
       case 6:
            button(60,  370, "fls",  win, 0);
            make_env();
            strcpy(tempstr,"flscmd -la > ");
            tmpnam(tempname);
            strcat(tempstr,tempname);
            status = execute(tempstr);
            if (!status) {
             strcpy(currdir, rdirname);
             dirlen = strlen(rdirname);
             flist();
            }
            unlink(tempname);
            break;
       case 7:
            button(110, 370, "fget", win, 0);
            strcpy(tempstr,"fgetcmd ");
            strcat(tempstr,rfilname);
            strcat(tempstr," &");
            status = execute(tempstr);
            break;
       case 8:
            button(160, 370, "fput", win, 0);
            strcpy(tempstr,"fput ");
            strcat(tempstr,lfilname);
            strcat(tempstr," &");
            status = execute(tempstr);
            break;
       case 9:
            button(210, 370, "fcd", win, 0);
            strcpy(tempstr,"fcdcmd ");
            strcat(tempstr,rdirname);
            status = execute(tempstr);
            if (!status) {
             strcpy(currdir,rdirname);
             entries = 0;
             showentries();
            }
            break;
       case 10:
            button(260, 370, "about", win, 0);
            abouts();
            break;
       case 11:
            button(440, 370, "quit", win, 0);
            runend();
            break;
       case 12:
            button(10, 330, "rfile", win, 0);
            break;
   }  /* End switch */
   litbutton = 0;
   if (bx >= 475 && bx <=491) {
    if (by >= 247 & by <= 263) {
     if (topent < entries - 16)  topent++;
    }
    if (by >= 48 && by <= 64) {
     if (topent > 0)  topent = topent - 1;
    }
    if (by >= 30 && by <= 46) {
     if (topent > 16) topent = topent - 16;
     else
     topent = 0;
     }
    if (by >= 265 && by <= 281) {
     if (topent < entries - 32) topent = topent + 16;
      else
      topent = entries - 16;
     }
    if (topent < 0) topent = 0;
    showentries();
    }
  if (topent < 0) topent = 0;
  }
  else
    {
   if ((bx >= 10 && bx <= 460) && (by >= 30 & by <= 280)) selfile(by);
   if ((bx >= 10 && bx <= 50) && (by >= 370 & by <= 385))
      { 
       button(10, 370, "hosts", win, lit);
       litbutton = 5;
       litstr = 0;
      }
   if ((bx >= 60 && bx <= 100) && (by >= 370 && by <= 385)) 
      {
       button(60, 370, "fls", win, lit);
       litbutton = 6;
       litstr = 0;
      }
   if ((bx >= 110 && bx <= 150) && (by >= 370 && by <= 385)) 
      {
       button(110, 370, "fget", win, lit);
       litbutton = 7;
       litstr = 0;
      }
   if ((bx >= 160 && bx <= 200) && (by >= 370 && by <= 385)) 
      {
       button(160, 370, "fput", win, lit);
       litbutton = 8;
       litstr = 0;
      }
   if ((bx >= 210 && bx <= 250) && (by >= 370 && by <= 385)) 
      {
       button(210, 370, "fcd", win, lit);
       litbutton = 9;
       litstr = 0;
      }
   if ((bx >= 260 && bx <= 300) && (by >= 370 && by <= 385)) 
      {
       button(260, 370, "about", win, lit);
       litbutton = 10;
       litstr = 0;
      }
   if ((bx >= 10 && bx <= 50) && (by >= 290 && by <= 305))
      {
       button(10, 290, "host", win, lit);
       litbutton = 1;
       litstr = 1;
      }
   if ((bx >= 380 && bx <= 420) && (by >= 290 && by <= 305))
      {
       button(380, 290, "port", win, lit);
       litbutton = 2;
       litstr = 2;
      }
   if ((bx >= 10 && bx <= 50) && (by >= 310 && by <= 325))
      {
       button(10, 310, "r-dir", win, lit);
       litbutton = 3;
       litstr = 3;
       }
   if ((bx >= 250 && bx <= 290) && (by >= 330 && by <= 345))
      {
       button(250, 330, "lfile", win, lit);
       litstr = 4;
       litbutton = 4;
       }
   if ((bx >= 10 && bx <= 50) && (by >= 330 && by <= 345))
      {
       button(10, 330, "rfile", win, lit);
       litstr = 5;
       litbutton = 12;
       }
   if ((bx >= 440 && bx <= 480) && (by >= 370 && by <= 385))
     {
      button(440, 370, "quit", win, lit);
      litbutton = 11;
      litstr = 0;
     }
  showstrings();
  }
 }
 if (bw == hostwin)
 {
  if ((bx >= 10 && bx <= 50) && (by >= 250 && by <= 265)) {
   button(10, 250, "hfile", hostwin, lit);
   litbutton = 13;
   litstr = 6;
  }
  if ((bx >= 420 && bx <= 460) && (by >= 250 && by <= 265)) {
   XUnmapWindow(dpy, hostwin);
   hoston = 0;
   mainscr();
  }
  if (!lit) {
   if (litbutton == 13) {
    button(10, 250, "hfile", hostwin, 0);
    litbutton = 0;
    }
   if ((bx >= 0 && bx <= 480) && (by >= 20 && by <= 240)) selhost(by);
   if (bx >= 465 && bx <=481) {
    if (by >= 207 && by <= 223) {
     if (tophost < numhosts - 14)  tophost++;
    }
    if (by >= 38 && by <= 54) {
     if (tophost > 0)  tophost = tophost - 1;
    }
    if (by >= 20 && by <= 36) {
     if (tophost > 14) tophost = tophost - 14;
     else
     tophost = 0;
     }
    if (by >= 225 && by <= 241) {
     if (tophost < numhosts - 28) tophost = tophost + 14;
      else
      tophost = numhosts - 14;
     }
    if (tophost < 0) tophost = 0;
    showhosts();
   }
  }
 hoststring();
 }
}
