#include "xfsp.h"

#include "maxup.h"
#include "up.h"
#include "down.h"
#include "maxdown.h"
#include "xfsp.xbm"

extern Display *dpy;
extern int screen_num;
extern char *dpy_name;
extern Window win, hostwin, aboutwin;
extern GC gc;
extern unsigned long bg, fg;
extern Pixmap down, up, maxdown, maxup,  logo;
extern int ddepth, litbutton, litstr, tophost, numhosts;
extern char hostname[40], portname[6], lfilname[30], rdirname[70];
extern char rfilname[30], hostf[40];
extern char dates[256][20], sizes[256][10], names[256][30];
extern char Lhosts[50][40], Lports[50][6], Lcomments[50][30];
extern dirlen, topent;
extern int dirs[256], entries, hoston;
extern XFontStruct *font;

mainscr()
{
  XDrawRectangle(dpy, win, gc, 10, 10, 480, 270);
  XDrawLine(dpy, win, gc, 10, 30, 490, 30);
  XDrawString(dpy, win, gc, 20, 25, "Name:", 5);
  XDrawString(dpy, win, gc, 250, 25, "Date:", 5);
  XDrawString(dpy, win, gc, 350, 25, "Size:", 5);
  XCopyArea(dpy, maxup, win, gc, 0, 0, maxup_width, maxup_height, 475, 30);
  XCopyArea(dpy,maxdown,win,gc,0,0, maxdown_width, maxdown_height, 475, 265);
  XCopyArea(dpy, up, win, gc, 0, 0, up_width, up_height, 475, 48);
  XCopyArea(dpy, down, win, gc, 0, 0, down_width, down_height, 475, 247);
  button(10,  290, "host", win, 0);
  button(380, 290, "port", win, 0);
  button(10,  310, "r-dir", win, 0);
  button(10,  330, "rfile",win, 0);
  button(250, 330, "lfile", win, 0);
  button(10,  370, "hosts", win, 0);
  button(60,  370, "fls",  win, 0);
  button(110, 370, "fget", win, 0);
  button(160, 370, "fput", win, 0);
  button(210, 370, "fcd", win, 0);
  button(260, 370, "about",win, 0);
  button(440, 370, "quit", win, 0);
  showstrings();
  showentries();
}

button(x, y, textstr, vwin, lit)
int x, y, lit;
Window vwin;
char *textstr;
{
  XPoint poly[9];
  int h, w, r, tx, tw;

  w = 40;
  h = 15;
  r = 3;
  poly [0].x = x;
  poly [0].y = y+r;
  poly [1].x = x;
  poly [1].y = y+h-r;
  poly [2].x = x+r;
  poly [2].y = y+h;
  poly [3].x = x+w-r;
  poly [3].y = y+h;
  poly [4].x = x+w;
  poly [4].y = y+h-r;
  poly [5].x = x+w;
  poly [5].y = y+r;
  poly [6].x = x+w-r;
  poly [6].y = y;
  poly [7].x = x+r;
  poly [7].y = y;
  poly [8].x = x;
  poly [8].y = y+r;
  if (!lit) XSetForeground (dpy, gc, bg);
  else XSetForeground (dpy, gc, fg);
  XFillPolygon (dpy, vwin, gc, poly, 9, Convex, CoordModeOrigin);
  XSetForeground(dpy, gc, fg);
  XDrawLines(dpy, vwin, gc, poly, 9, CoordModeOrigin);
  tw = (XTextWidth(font, textstr, strlen(textstr))) / 2;
  tx = ((x+(w/2))-tw);
  if (lit) XSetForeground (dpy, gc, bg);
  else XSetForeground (dpy, gc, fg);
  XDrawString(dpy, vwin, gc, tx, y+12, textstr, strlen(textstr));
}

showstrings()
{
char outstr[60];

  XSetForeground(dpy, gc, fg);
  XClearArea(dpy, win, 61, 291, 308, 13, False);
  XDrawRectangle(dpy, win, gc, 60, 290, 310, 15);
  strcpy(outstr, hostname);
  if (litstr == 1) strcat(outstr,"*");
  limstr(win, 63, 302, outstr, 310);
  XClearArea(dpy, win, 430, 290, 60, 15, False);
  XDrawRectangle(dpy, win, gc, 430, 290, 60, 15);
  strcpy(outstr, portname);
  if (litstr == 2) strcat(outstr,"*");
  limstr(win, 433, 302, outstr, 60);
  XClearArea(dpy, win, 60, 310, 430, 15, False);
  XDrawRectangle(dpy, win, gc, 60, 310, 430, 15);
  strcpy(outstr, rdirname);
  if (litstr == 3) strcat(outstr,"*");
  limstr(win, 63, 322, outstr, 430);
  XClearArea(dpy, win, 300, 330, 190, 15, False);
  XDrawRectangle(dpy, win, gc, 300, 330, 190, 15);
  strcpy(outstr, lfilname);
  if (litstr == 4) strcat(outstr,"*");
  limstr(win, 303, 342, outstr, 190);
  XClearArea(dpy, win, 60, 330, 170, 15, False);
  XDrawRectangle(dpy, win, gc, 60, 330, 170, 15);
  strcpy(outstr, rfilname);
  if (litstr == 5) strcat(outstr,"*");
  limstr(win, 63, 342, outstr, 170);
  if (hoston) hoststring();
}

showentries()
{
char entry[50];
int i, s, w, y = 45;

 XClearArea(dpy, win, 11, 31, 460, 248, False);
 if (entries == 0) {
  XDrawString(dpy, win, gc, 200, 150,"No entries available." , 21);
 }
 else
 {
  if (entries < 16) s = entries;
  else
  s = topent + 16;
  for (i = topent; i < s ; i ++) {
  strcpy(entry,names[i]);
  if (dirs[i]) strcat(entry,"/");
  limstr(win, 20, y, entry , 220);
  limstr(win, 250, y, dates[i], 100);
  limstr(win, 350, y, sizes[i] , 150);
  y = y + 15;
  }
 }
}

limstr(w, x, y, s, lim)
int x, y, lim;
Window w;
char *s;
{
 int width;
  width = strlen(s);
  while (XTextWidth(font, s, width) > lim) width = width - 1;
  XDrawString(dpy, w, gc, x, y, s , width);
}

makepix()
{
 up = XCreatePixmapFromBitmapData(dpy, win, up_bits,
         up_width,up_height, fg, bg, ddepth);
 down = XCreatePixmapFromBitmapData(dpy, win, down_bits,
         down_width,down_height, fg, bg, ddepth);
 maxup = XCreatePixmapFromBitmapData(dpy, win, maxup_bits,
         maxup_width,maxup_height, fg, bg, ddepth);
 maxdown = XCreatePixmapFromBitmapData(dpy, win, maxdown_bits,
         maxdown_width,maxdown_height, fg, bg, ddepth);
 logo = XCreatePixmapFromBitmapData(dpy, win, xfsp_bits,
         xfsp_width, xfsp_height, fg, bg, ddepth);

}

hosts()
{
 hostwin = XCreateSimpleWindow(dpy, win, 10, 10, 480, 270, 4, fg, bg);
 XSelectInput (dpy, hostwin, ExposureMask | ButtonPressMask |
               ButtonReleaseMask);
 XMapRaised (dpy, hostwin);
 hoston = 1;
 hostscr();
}

hostscr()
{
 XDrawLine(dpy, hostwin, gc, 0, 20, 480, 20);
 XDrawLine(dpy, hostwin, gc, 0, 240, 480, 240);
 XDrawString(dpy, hostwin, gc, 15, 15, "Host:", 5);
 XDrawString(dpy, hostwin, gc, 225, 15, "Port:", 5);
 XDrawString(dpy, hostwin, gc, 300, 15, "Comment:",8);
 XCopyArea(dpy, maxup, hostwin, gc, 0, 0, maxup_width, maxup_height, 465,20);
 XCopyArea(dpy, up, hostwin, gc, 0, 0, maxup_width, maxup_height, 465,38);
 XCopyArea(dpy, down, hostwin, gc, 0, 0, maxup_width, maxup_height, 465,207);
 XCopyArea(dpy, maxdown,hostwin, gc, 0, 0, maxup_width, maxup_height,465,225);
 button(420,250,"close", hostwin, 0);
 button(10,250,"hfile", hostwin, 0);
 hoststring();
 showhosts();
}

hoststring()
{
  char outstr[60];

  XSetForeground(dpy, gc, fg);
  XClearArea(dpy, hostwin, 61, 251, 290, 13, False);
  XDrawRectangle(dpy, hostwin, gc, 60, 250, 290, 15);
  strcpy(outstr, hostf);
  if (litstr == 6) strcat(outstr,"*");
  limstr(hostwin, 63, 263, outstr, 220);
}

showhosts()
{
int i, s, w, y = 35;

 XClearArea(dpy, hostwin, 0, 21, 460, 219, False);
 if (numhosts == 0)
  XDrawString(dpy, hostwin, gc, 200, 150,"No hosts available." , 19);
 else
 {
  if (s < 14) s = numhosts;
  else
  s = tophost + 14;
  for (i = tophost; i < s ; i ++) {
  limstr(hostwin, 5, y, Lhosts[i] , 210);
  limstr(hostwin, 225, y, Lports[i], 75);
  limstr(hostwin, 300, y, Lcomments[i] , 160);
  y = y + 15;
  }
 }
}

abouts()
{
 aboutwin = XCreateSimpleWindow(dpy, win, 0, 0, 490, 150, 4, fg, bg);
 XSelectInput (dpy, aboutwin, ExposureMask | ButtonPressMask);
 XMapRaised (dpy, aboutwin);
 aboutscr();
}

aboutscr()
{
 XCopyArea(dpy, logo, aboutwin, gc, 0, 0, xfsp_width, xfsp_height, 20, 35);
 XDrawString(dpy, aboutwin, gc, 305, 35, "X-FSP Version 1.00", 18);
 XDrawString(dpy, aboutwin, gc, 300, 70, "An X based front-end", 20);
 XDrawString(dpy, aboutwin, gc, 300, 90, "for the FSP package.", 20);
 XDrawString(dpy, aboutwin, gc, 250, 140,
    "E-Mail :- Steff.Watkins@bristol.ac.uk", 37);
}
