.TH XFSP 1 "25 October 1993" "X Version 11"
.SH NAME
xfsp - X11 front end for the FSP suite [Version 1.0]
.SH SYNOPSIS
.B xfsp  
[-display disp] [-geometry geom]
.SH DESCRIPTION
.I Xfsp
is a graphical front end for the FSP suite of programs.
.PP
.I Xfsp
currently only supports four FSP commands (fcd, fls, fget, fput). By using
the text boxes included, it is possible to alter several of the FSP
environment variables such as FSP_HOST, and FSP_PORT.

.I Xfsp
supports a "hosts" file, which is used to contain a list of FSP hosts, and
their ports.

See the file README for more information on how to use the "hosts" file
feature.

.SH OPTIONS
.I Xfsp
accepts the command line options listed below:
.PP
.TP 12
.B -display
Sets the display to the specified name (Resource name: display, Type: string,
Default: none).
.TP 12
.B -geometry
Specifies the
.I xfsp
position on the screen. You can't resize the window
(Resource name: geometry, Type: string, Default: none).
.SH DIAGNOSTICS
.I Xfsp
exits with EOF (-1) if a fatal error occurs, otherwise with zero (0).
.SH AUTHOR
Copyright (c) 1993 by
.PP
.I Steff Watkins
.br
Computing Service,
.br
University of Bristol,
.br
Tyndalls Avenue,
.br
Bristol BS8 1UD
.br
England
.PP
Access: Steff.Watkins@bristol.ac.uk
.SH BUGS
The access protections on some remote FSP directories can cause xfsp to fail.
